const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const post_comments = sequelize.define(
    'post_comments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

body: {
        type: DataTypes.TEXT,
      
      

      },

is_pinned: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

commented_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  post_comments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.post_comments.belongsTo(db.posts, {
      as: 'post',
      foreignKey: {
        name: 'postId',
      },
      constraints: false,
    });

    db.post_comments.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.post_comments.belongsTo(db.post_comments, {
      as: 'parent_comment',
      foreignKey: {
        name: 'parent_commentId',
      },
      constraints: false,
    });




    db.post_comments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.post_comments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return post_comments;
};


